PropertyWrapperDefinitionImpl (Media Authoring with Java API)
Date: 2016-02-05

tv.amwa.maj.meta.impl

## Class PropertyWrapperDefinitionImpl

- java.lang.Object
- - tv.amwa.maj.meta.impl.MetaDefinitionImpl
  - - tv.amwa.maj.meta.impl.PropertyDefinitionImpl
    - - tv.amwa.maj.meta.impl.PropertyWrapperDefinitionImpl

- All Implemented Interfaces:
    Serializable, Cloneable, Comparable<PropertyDefinition>, CommonConstants, MetadataObject, WeakReferenceTarget, XMLSerializable, MetaDefinition, PropertyDefinition, PropertyWrapperDefinition, DefinitionType

      @MediaClass(uuid1=218169601,
                  uuid2=551,
                  uuid3=0,
                  uuid4={6,14,43,52,2,6,1,1},
                  definedName="PropertyWrapperDefinition",
                  symbol="PropertyWrapperDefinition",
                  description="Globally unique alias for a property that was originally defined to be used in another class. This allows the property to be used unambiguously in more than one class.")
      public class PropertyWrapperDefinitionImpl
      extends PropertyDefinitionImpl
      implements PropertyWrapperDefinition, Cloneable, Serializable

  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from interface tv.amwa.maj.constant.CommonConstants

      `AAF_METADICT_NAMESPACE, AAF_METADICT_PREFIX, AAF_XML_NAMESPACE, AAF_XML_PREFIX, ApplicationPluginObjectID, ApplicationPluginsID, MAX_NUM_RGBA_COMPS, MemberOfID, ObjectClassID, ParentClassID, PropertiesID, XMLClassIDAsAttributeName`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PropertyWrapperDefinitionImpl()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `PropertyWrapperDefinition` | `clone()` Create a cloned copy of this meta definition.
    `PropertyDefinition` | `getOriginalProperty()` Returns the original definition of the reused property.
    `void` | `setOriginalProperty(PropertyDefinition propertyDefinition)` Sets the original definition of the reused property.

    - ### Methods inherited from class tv.amwa.maj.meta.impl.PropertyDefinitionImpl

      `appendMetadictXML, appendXMLChildren, compareTo, getFlattenXML, getIsOptional, getIsUniqueIdentifier, getIsXMLAttribute, getIsXMLCDATA, getLocalIdentification, getMemberOf, getMethodBag, getNamespace, getPrefix, getPropertyType, getPropertyValue, getTypeDefinition, getWeight, initalizePropertyNameMap, initializeIsOptional, initializeLocalIdentification, initializePropertyType, isPropertyPresent, nameToAAFName, omitOptionalProperty, setAnnotatedGetter, setIsOptional, setIsUniqueIdentifier, setLocalIdentification, setMemberOf, setPropertyType, setPropertyValue, setTypeDefinition`

    - ### Methods inherited from class tv.amwa.maj.meta.impl.MetaDefinitionImpl

      `aafNameToName, deepEquals, equals, getAAFNamesInUse, getAliases, getAUID, getComment, getDescription, getIdentification, getName, getSymbol, getWeakTargetReference, hashCode, initializeMetaDefinitionIdentification, initializeMetaDefinitionName, setAAFNamesInUse, setAliases, setDescription, setIdentification, setName, setNamespace, setPrefix, setSymbol, toString`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface tv.amwa.maj.meta.PropertyDefinition

      `getFlattenXML, getIsOptional, getIsUniqueIdentifier, getIsXMLAttribute, getIsXMLCDATA, getLocalIdentification, getMemberOf, getPropertyType, getPropertyValue, getSymbol, getTypeDefinition, getWeight, isPropertyPresent, omitOptionalProperty, setMemberOf, setPropertyValue`

    - ### Methods inherited from interface tv.amwa.maj.meta.MetaDefinition

      `appendMetadictXML, deepEquals, equals, getAAFNamesInUse, getAliases, getAUID, getDescription, getName, getNamespace, getPrefix, hashCode, setAAFNamesInUse, setDescription, setName, setNamespace, setPrefix, setSymbol, toString`

    - ### Methods inherited from interface tv.amwa.maj.industry.WeakReferenceTarget

      `getWeakTargetReference`

    - ### Methods inherited from interface java.lang.Comparable

      `compareTo`

    - ### Methods inherited from interface tv.amwa.maj.io.xml.XMLSerializable

      `getComment`

- - ### Constructor Detail

    - #### PropertyWrapperDefinitionImpl

          public PropertyWrapperDefinitionImpl()

  - ### Method Detail

    - #### getOriginalProperty

          @MediaProperty(uuid1=100729095,
                         uuid2=8192,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,13},
                         definedName="OriginalProperty",
                         typeName="PropertyDefinitionWeakReference",
                         optional=false,
                         uniqueIdentifier=false,
                         pid=41,
                         symbol="OriginalProperty",
                         description="Original definition of the reused property.")
          public PropertyDefinition getOriginalProperty()

      Description copied from interface: `PropertyWrapperDefinition`

      Returns the original definition of the reused property.

      Specified by:
        `getOriginalProperty` in interface `PropertyWrapperDefinition`
      Returns:
        Original definition of the reused property.

    - #### setOriginalProperty

          @MediaPropertySetter(value="OriginalProperty")
          public void setOriginalProperty(PropertyDefinition propertyDefinition)
                                                                                  throws NullPointerException,
                                                                                         IllegalArgumentException

      Description copied from interface: `PropertyWrapperDefinition`

      Sets the original definition of the reused property.

      Specified by:
        `setOriginalProperty` in interface `PropertyWrapperDefinition`
      Parameters:
        `propertyDefinition` - Original definition of the reused property.
      Throws:
        `NullPointerException` - Cannot set the original property definition using a `null` value.
        `IllegalArgumentException` - The given property definition is not compatible with this property, for example it has the same identification or is for a different type.

    - #### clone

          public PropertyWrapperDefinition clone()

      Description copied from interface: `MetaDefinition`

      Create a cloned copy of this meta definition.

      Specified by:
        `clone` in interface `MetaDefinition`
      Specified by:
        `clone` in interface `PropertyDefinition`
      Specified by:
        `clone` in interface `PropertyWrapperDefinition`
      Overrides:
        `clone` in class `PropertyDefinitionImpl`
      Returns:
        Cloned copy of this meta definition.

(c)2007-2016 Richard Cartwright, all rights reserved. Licensed under Apache 2 license and subject to the AMWA IPR policy.